%global ftest_commit c4ad4af0946b73ce1a40cbc72205d15d196c7e06
%global ftest_shortcommit %(c=%{ftest_commit}; echo ${c:0:7})

Name:       utf8cpp
Version:    4.0.6
Release:    %mkrel 1
Summary:    A simple, portable and lightweight library for handling UTF-8 encoded strings

Group:      Development/C++
License:    Boost
URL:        https://github.com/nemtrif/utfcpp
Source0:    https://github.com/nemtrif/utfcpp/archive/v%{version}/utfcpp-%{version}.tar.gz
Source1:    https://github.com/nemtrif/ftest/archive/%{ftest_commit}/ftest-%{ftest_shortcommit}.tar.gz
# put cmake import file in arch-agnostic directory
Patch1:     utf8cpp-cmake-config-dir.patch
# This package only contains header files
BuildArch:  noarch

BuildRequires: cmake
BuildRequires: gcc-c++


%description
A simple, portable and lightweight library for handling UTF-8 encoded strings.

Features include:
 - iterating through UTF-8 encoded strings
 - converting between UTF-8 and UTF-16/UTF-32
 - detecting invalid UTF-8 sequences

This project currently only contains header files, which can be found in the
%{name}-devel package.

%package    devel
Summary:    Header files for %{name}
Group:      Development/C++
BuildArch:  noarch
Provides:   %{name}-static = %{version}-%{release}

%description devel
A simple, portable and lightweight library for handling UTF-8 encoded strings.

Features include:
 - iterating through UTF-8 encoded strings
 - converting between UTF-8 and UTF-16/UTF-32
 - detecting invalid UTF-8 sequences

This project currently only contains header files, which can be found in the
%{name}-devel package.


%prep
%autosetup -n utfcpp-%{version} -p1 -a1

rmdir extern/ftest && mv ftest-%{ftest_commit} extern/ftest


%build
%cmake
%cmake_build

pushd tests
%cmake
%cmake_build
popd

%install
%cmake_install

pushd %{buildroot}%{_includedir}
ln -s utf8cpp/utf8.h ./
mkdir utf8
for f in {{un,}checked,core,cpp{11,17,20}}.h ; do
    ln -s ../utf8cpp/utf8/${f} utf8/
done
popd


%check
pushd tests
%ctest
popd

%files devel
%doc README.md
%license LICENSE
%{_includedir}/utf8.h
%dir %{_includedir}/utf8
%{_includedir}/utf8/checked.h
%{_includedir}/utf8/core.h
%{_includedir}/utf8/cpp11.h
%{_includedir}/utf8/cpp17.h
%{_includedir}/utf8/cpp20.h
%{_includedir}/utf8/unchecked.h
%{_includedir}/utf8cpp/
%{_datadir}/cmake/utf8cpp


%changelog
* Fri Nov 22 2024 daviddavid <daviddavid> 4.0.6-1.mga10
+ Revision: 2118520
- new version: 4.0.6

* Thu Aug 22 2024 daviddavid <daviddavid> 4.0.5-2.mga10
+ Revision: 2087407
- fix missing cpp20.h in /include/utf8/ dir

* Fri Apr 26 2024 daviddavid <daviddavid> 4.0.5-1.mga10
+ Revision: 2061195
- new version: 4.0.5

* Tue Sep 05 2023 daviddavid <daviddavid> 3.2.4-1.mga10
+ Revision: 1984423
- new version: 3.2.4

* Tue Jan 10 2023 daviddavid <daviddavid> 3.2.3-1.mga9
+ Revision: 1932026
- new version: 3.2.3

* Wed Dec 14 2022 daviddavid <daviddavid> 3.2.2-1.mga9
+ Revision: 1921911
- new version: 3.2.2

* Tue Dec 06 2022 daviddavid <daviddavid> 3.2.1-1.mga9
+ Revision: 1918407
- new version: 3.2.1

* Tue Mar 29 2022 umeabot <umeabot> 3.1.2-2.mga9
+ Revision: 1833012
- Mageia 9 Mass Rebuild

* Thu Oct 22 2020 daviddavid <daviddavid> 3.1.2-1.mga8
+ Revision: 1638278
- new version: 3.1.2

* Thu Aug 20 2020 joequant <joequant> 3.1.1-2.mga8
+ Revision: 1616799
- fix build

* Fri May 29 2020 daviddavid <daviddavid> 3.1.1-1.mga8
+ Revision: 1588778
- new version: 3.1.1

* Mon Feb 17 2020 umeabot <umeabot> 3.1-3.mga8
+ Revision: 1537174
- Mageia 8 Mass Rebuild
+ wally <wally>
- build with new cmake macros

* Sun Oct 27 2019 daviddavid <daviddavid> 3.1-2.mga8
+ Revision: 1455995
- use default upstream include path and symlink the previous one for backward compatibility

* Sun Oct 27 2019 daviddavid <daviddavid> 3.1-1.mga8
+ Revision: 1455990
- new version: 3.1
- include cmake import file

* Wed Oct 23 2019 daviddavid <daviddavid> 2.3.6-1.mga8
+ Revision: 1455269
- new version: 2.3.6
- update URL and Source URL
- switch to cmake build system

* Wed Sep 19 2018 umeabot <umeabot> 2.3.4-3.mga7
+ Revision: 1276943
- Mageia 7 Mass Rebuild

* Fri Feb 19 2016 umeabot <umeabot> 2.3.4-2.mga6
+ Revision: 968379
- Mageia 6 Mass Rebuild

* Mon Jul 06 2015 remmy <remmy> 2.3.4-1.mga6
+ Revision: 852150
- imported package utf8cpp

